function [xdot y] = pipeline(t,x,u,p,noW,noP,R)

l=1;
for i=1:6:noP*6
    
    m_Gp(l) = x(3*noW+i);
    m_Op(l) = x(3*noW+i+1);
    m_Wp(l) = x(3*noW+i+2);

    m_Gr(l) = x(3*noW+i+3);
    m_Or(l) = x(3*noW+i+4);
    m_Wr(l) = x(3*noW+i+5);
    

    V_Gp(l)     = p.V_p-m_Op(l)/p.rho_o-m_Wp(l)/p.rho_w;
    rho_Gp(l)   = m_Gp(l)/V_Gp(l);
    P_p(l)      = (rho_Gp(l)*p.R*p.T_p)/(p.M_g); %Manifold pressure for manifold l
    l=l+1;
end


k = 1;
q=1;
for i=1:3:noW*3
    
    m_ga(k)=x(i);
    m_gt(k)=x(i+1);
    m_lt(k)=x(i+2);

    u_pc(k)=u(q);
    u_gl(k)=u(q+1);
    q=q+2;

    m_t(k)=m_lt(k)+m_gt(k);

    
    rho_Lw=p.r_wc(k)*p.rho_w+(1-p.r_wc(k))*p.rho_o;

    r_glr=(1-p.r_wc(k))*p.r_gor(k);
    
 
   
    for l=1:noP
        if(R(l,k) == 1)
            p_m = P_p(l); %Manifold pressure
        end
    end

    p_p(k)=(p.R*p.T_t*m_gt(k))/(p.M_g*p.V_t(k)-p.M_g*(1/rho_Lw)*m_lt(k))-(p.g*m_t(k))/(2*p.A_t);

    
    p_ti=p_p(k)+(p.g*m_t(k))/p.A_t;
    p_bh=((1+r_glr+(r_glr*p.M_g*p.g*p.L_w(k))/(2*p.R*p.T_t))*p_ti+rho_Lw*p.g*p.L_w(k))/(1+r_glr-(r_glr*p.M_g*p.g*p.L_w(k))/(2*p.R*p.T_t));
    p_ai=((p.R*p.T_a)/(p.V_a(k)*p.M_g)+p.g/(2*p.A_a))*m_ga(k);
    rho_p=(rho_Lw*p.M_g*p_p(k)*m_t(k))/(rho_Lw*p.R*p.T_t*m_lt(k)+p.M_g*p_p(k)*m_gt(k));
    rho_gi=(p.M_g/(p.R*p.T_a))*p_ai;
    
    for l=1:noP
        if(R(l,k) == 1)
            %w_p(k)=p.C_pc*sqrt(rho_p*max(0,p_p(k)-P_p(l)))*u_pc(k);
            w_p(k) = p.C_pc*sqrt(rho_p*(((0-(p_p(k)-P_p(l)))^2+eps^2)^0.5/2+(0+(p_p(k)-P_p(l)))/2));
        end
    end
    
    
    
    w_lp(k)=(m_lt(k)/m_t(k))*w_p(k);
    w_gp(k)=(m_gt(k)/m_t(k))*w_p(k);

    w_lr(k)=rho_Lw*p.Q_max(k)*(1-(1-p.C)*(p_bh/p.p_r)-p.C*(p_bh/p.p_r)^2);
    w_gr(k)=r_glr*w_lr(k);
    
    %w_gi(k)=p.C_iv*sqrt(rho_gi*max(0,p_ai-p_ti));
    w_gi(k) = p.C_iv*sqrt(rho_gi*((((0-(p_ai-p_ti))^2+eps^2)^0.5)/2+(0+(p_ai-p_ti))/2));
    
    w_gl(k)=u_gl(k);

    w_op(k)=(1-p.r_wc(k))*w_lp(k);
    w_wp(k)=p.r_wc(k)*w_lp(k);

    w_out(:,k) = [w_gp(k);w_op(k);w_wp(k)];

    

    k=k+1;
    
end

W_in = w_out*R';
    
for l=1:noP
    w_Gin(l) = W_in(1,l);
    w_Oin(l) = W_in(2,l);
    w_Win(l) = W_in(3,l);
end

% To pipeline

for l=1:noP

    rho_Lp = ((p.rho_o*p.rho_w)/(p.rho_w*m_Op(l)+p.rho_o*m_Wp(l)))*(m_Op(l)+m_Wp(l));
    
    mu_Lp = (m_Wp(l)/(m_Wp(l)+m_Op(l)))*p.mu_w+(m_Op(l)/(m_Wp(l)+m_Op(l)))*p.mu_o;
    

    U_slp = (p.rho_w*w_Oin(l)+p.rho_o*w_Win(l))/(p.rho_o*p.rho_w*pi*p.r_p^2);
    Re_p = (2*rho_Lp*U_slp*p.r_p)/mu_Lp;

    lambda_p = (1/(-1.8*log10((p.epsilon/(3.7*p.D_p))^1.11+6.9/Re_p)))^2;

    alpha_Lp = (p.rho_w*m_Op(l)+p.rho_o*m_Wp(l))/(p.rho_o*p.rho_w*p.V_p);
    DP_fp = (alpha_Lp*p.L_p*rho_Lp*lambda_p*U_slp^2)/(4*p.r_p);

    % Riser

    V_Gr = p.V_r-m_Or(l)/p.rho_o-m_Wr(l)/p.rho_w;
    rho_Gr = m_Gr(l)/V_Gr;
    
    P_r(l) = (rho_Gr*p.R*p.T_r)/p.M_g; %Pressure riser top

    U_slr = (p.rho_w*w_Oin(l)+p.rho_o*w_Win(l))/(p.rho_w*p.rho_o*pi*p.r_r^2);
    
    U_sgr = (w_Gin(l))/(rho_Gr*pi*p.r_r^2);
    U_mr = U_slr+U_sgr;
    rho_m = (m_Gr(l)+m_Or(l)+m_Wr(l))/p.V_r;
    
    mu_Lr = (m_Wr(l)/(m_Wr(l)+m_Or(l)))*p.mu_w+(m_Or(l)/(m_Wr(l)+m_Or(l)))*p.mu_o;
    Re_r = (2*rho_m*U_mr*p.r_r)/mu_Lr;
    
    lambda_r = (1/(-1.8*log10((p.epsilon/(3.7*p.D_r))^1.11+6.9/Re_r)))^2;

    alpha_Lr = (p.rho_w*m_Or(l)+p.rho_o*m_Wr(l))/(p.rho_w*p.rho_o*p.V_r);
    
    DP_fr = (alpha_Lr*lambda_r*rho_m*(U_mr^2)*p.L_r)/(4*p.r_r);

    % Connection pipeline-riser
    P_1(l) = P_p(l)-DP_fp;
    P_2(l) = P_r(l)+DP_fr+rho_m*p.g*p.L_r;

    DP_pr = P_1(l)-P_2(l);

    A_Gp = (V_Gp(l)/p.V_p)*p.A_p;
    A_Lp = p.A_p-A_Gp;

    %w_Glp(l) = p.K_Gp*A_Gp*sqrt(rho_Gp(l)*max(0,DP_pr));
    %w_Olp(l) = p.K_Lp*A_Lp*sqrt(p.rho_o*max(0,DP_pr))*(m_Op(l)/(m_Gp(l)+m_Op(l)+m_Wp(l)));
    %w_Wlp(l) = p.K_Lp*A_Lp*sqrt(p.rho_w*max(0,DP_pr))*(m_Wp(l)/(m_Gp(l)+m_Op(l)+m_Wp(l)));
    
    beta=0.01;
    %w_Glp(l) = p.K_Gp*A_Gp*sqrt(rho_Gp(l)*((((0-DP_pr)^2+eps^2)^(0.5))/2)+(0+DP_pr)/2);
    %w_Olp(l) = p.K_Lp*A_Lp*sqrt(p.rho_o*((((0-DP_pr)^2+epsilon^2)^(0.5))/2)+(0+DP_pr)/2)*(m_Op(l)/(m_Gp(l)+m_Op(l)+m_Wp(l)));
    %w_Wlp(l) = p.K_Lp*A_Lp*sqrt(p.rho_w*((((0-DP_pr)^2+epsilon^2)^(0.5))/2)+(0+DP_pr)/2)*(m_Wp(l)/(m_Gp(l)+m_Op(l)+m_Wp(l)));
    
    w_Glp(l) = p.K_Gp*A_Gp*sqrt(rho_Gp(l)*((((0-DP_pr)^2+beta^2)^(0.5))/2+(0+DP_pr)/2));    
    w_Olp(l) = p.K_Lp*A_Lp*sqrt(p.rho_o*((((0-DP_pr)^2+beta^2)^(0.5))/2+(0+DP_pr)/2))*(m_Op(l)/(m_Gp(l)+m_Op(l)+m_Wp(l)));
    w_Wlp(l) = p.K_Lp*A_Lp*sqrt(p.rho_w*((((0-DP_pr)^2+beta^2)^(0.5))/2+(0+DP_pr)/2))*(m_Wp(l)/(m_Gp(l)+m_Op(l)+m_Wp(l)));
     
    rho_Lr = ((p.rho_o*p.rho_w)/(p.rho_w*m_Or(l)+p.rho_o*m_Wr(l)))*(m_Or(l)+m_Wr(l));
    alpha_Lt = (2*(m_Or(l)+m_Wr(l)))/(p.V_r*rho_Lr)-A_Lp/(pi*p.r_p^2);
    rho_t = alpha_Lt*rho_Lr+(1-alpha_Lt)*rho_Gr;

    %w_mixout(l) = sqrt(rho_t*max(0,P_r(l)-p.P_s));
    w_mixout(l) = sqrt(rho_t*((((P_r(l)-p.P_s)^2+beta^2)^(0.5))/2+(0+P_r(l)-p.P_s)/2));
    
    w_Gout(l) = p.K_g*w_mixout(l)*(m_Gr(l)/(m_Gr(l)+m_Or(l)+m_Wr(l)));
    w_Oout(l) = p.K_l*w_mixout(l)*(m_Or(l)/(m_Gr(l)+m_Or(l)+m_Wr(l)));
    w_Wout(l) = p.K_l*w_mixout(l)*(m_Wr(l)/(m_Gr(l)+m_Or(l)+m_Wr(l)));
    
    
    %--

end



%Well
j=1;
for i=1:3:noW*3
    x_w(:,j) = [ w_gl(j)-w_gi(j);
                w_gr(j)+w_gi(j)-w_gp(j);
                w_lr(j)-w_lp(j);];
    j=j+1;
end

x_w_tot = [];

for i=1:length(x_w(1,:))
    x_w_tot = [x_w_tot;x_w(:,i)];
end

%Pipe 
for i=1:noP
    x_p(:,i) = [w_Gin(i)-w_Glp(i);
                w_Oin(i)-w_Olp(i);
                w_Win(i)-w_Wlp(i);
                w_Glp(i)-w_Gout(i);
                w_Olp(i)-w_Oout(i);
                w_Wlp(i)-w_Wout(i);];
end

x_p_tot = [];
for i=1:noP
    x_p_tot = [x_p_tot;x_p(:,i)];
end


xdot = [x_w_tot;
        x_p_tot;];

    w_IN = [];
    w_OUT = [];
for i=1:noP
    w_IN = [w_IN;[w_Gin(i);w_Oin(i);w_Win(i)]];
    w_OUT = [w_OUT;[w_Gout(i);w_Oout(i);w_Wout(i)]];
end


y = [w_IN;w_OUT;P_p(1);P_p(2)];
end