clc
clear
close all;

run set_well_parameters;
run set_piperiser_parameters;

noW = 5;
noP = 2;

tf = 5;                    % Hours 6.887
N=4;
u_in=1;
u(:,1) = [1;u_in;1;u_in;1;u_in;1;u_in;1;u_in];
R(:,:,1) = [1 1 0 0 0;
            0 0 1 1 1];  


u(:,2) = [1;1.3;1;1.1;1;1.5;1;1.6;1;1.7];
R(:,:,2) = [1 1 0 0 0;
            0 0 1 1 1];  

u(:,3) = [1;u_in;1;u_in;1;u_in;1;u_in;1;u_in];
R(:,:,3) = [1 1 0 0 0;
            0 0 1 1 1]; 
        
u(:,4) = [1;1.3;1;1.1;1;1.5;1;1.6;1;1.7];
R(:,:,4) = [1 1 0 0 0;
            0 0 1 1 1];  
run pipeline_init_point;


x0=[2954;938;6240;
    3389;854;8564;
    2238;754;4742;
    2399;975;3612;
    2279;726;5413;
    21838;15728;19774;405;3479;4604;
    21773;15105;12705;468;3500;3098;
    ];
    
tic
M=eye(3*noW+6*noP);
options=odeset('AbsTol',1e-6,'RelTol',1e-6,'Stats','on'); 
for i=1:N

    
    [t,x] = ode23t(@pipeline,[(i-1)*tf*3600/N;(i)*tf*3600/N],x0,options,u(:,i),p,noW,noP,R(:,:,i));
    t_int(i)=length(t);
    b=length(t)+b-1;
    for j=a:b 
        u_y(:,j)=u(:,i);
        R_y(:,:,j) = R(:,:,i);
    end
    a=b+1;
    

    x_total = [x_total;x(1:length(x(:,1))-1,:)];
    t_total = [t_total;t(1:length(t)-1,:)];
    x0 = x(length(x(:,1)),:)';
end
u_y=u_y';

xdot(:,:)=zeros(3*noW+6*noP,length(t_total));
y(:,:)=zeros(2*3*noP+2,length(t_total));

for i=1:length(t_total)
    [xdot(:,i) y(:,i)] = pipeline(t_total(i),x_total(i,:),u_y(i,:),p,noW,noP,R_y(:,:,i));
end

toc

clf

load('cvodes_profiles.mat')
t2=linspace(0,5*3600,length(m_gp1));

t_total = t_total./3600;
ts = ts./3600;

%%

figure(1)

subplot(5,1,1)
hold on
plot(t_total,x_total(:,1),'b--')
plot(ts,m_ga1,'b')
plot(t_total,x_total(:,2),'r--')
plot(ts,m_gt1,'r')
plot(t_total,x_total(:,3),'g--')
plot(ts,m_lt1,'g')

ylabel('Well 1')
title('Mass $[kg]$')
plotTickLatex2D

subplot(5,1,2)
hold on
plot(t_total,x_total(:,4),'b--')
plot(ts,m_ga2,'b')
plot(t_total,x_total(:,5),'r--')
plot(ts,m_gt2,'r')
plot(t_total,x_total(:,6),'g--')
plot(ts,m_lt2,'g')

ylabel('Well 2')
plotTickLatex2D

subplot(5,1,3)
hold on
plot(t_total,x_total(:,7),'b--')
plot(ts,m_ga3,'b')
plot(t_total,x_total(:,8),'r--')
plot(ts,m_gt3,'r')
plot(t_total,x_total(:,9),'g--')
plot(ts,m_lt3,'g')

ylabel('Well 3')
plotTickLatex2D

subplot(5,1,4)
hold on
plot(t_total,x_total(:,10),'b--')
plot(ts,m_ga4,'b')
plot(t_total,x_total(:,11),'r--')
plot(ts,m_gt4,'r')
plot(t_total,x_total(:,12),'g--')
plot(ts,m_lt4,'g')

ylabel('Well 4')
plotTickLatex2D

subplot(5,1,5)
hold on
h1=plot(t_total,x_total(:,13),'b--');
h2=plot(ts,m_ga5,'b');
h3=plot(t_total,x_total(:,14),'r--');
h4=plot(ts,m_gt5,'r');
h5=plot(t_total,x_total(:,15),'g--');
h6=plot(ts,m_lt5,'g');

xlabel('t $[h]$')
ylabel('Well 5')
plotTickLatex2D

set(gcf, 'units','centimeters');
set(gcf, 'position', [1, 2, 17.6, 20]) % [0 0 W H];

%legend( [h2 h4 h6],'$m_{ga}$','$m_{gt}$','$m_{lt}$')
legend( '$m_{ga}$ Matlab','$m_{ga}$ CVODE',...
        '$m_{gt}$ Matlab','$m_{gt}$ CVODE',...
        '$m_{lt}$ Matlab','$m_{lt}$ CVODE')
set(findall(gcf,'-property','interpreter'),'interpreter','latex') 



%% ---- FLOWLINES

figure(2)
clf

subplot(2,1,1)
hold on
plot(t_total,x_total(:,16),'c--')
plot(ts,m_gp1,'c')
plot(t_total,x_total(:,17),'b--')
plot(ts,m_op1,'b')
plot(t_total,x_total(:,18),'r--')
plot(ts,m_wp1,'r')

plot(t_total,x_total(:,19),'g--')
plot(ts,m_gr1,'g')
plot(t_total,x_total(:,20),'m--')
plot(ts,m_or1,'m')
plot(t_total,x_total(:,21),'k--')
plot(ts,m_wr1,'k')


title('Mass $[kg]$')
ylabel('Flowline 1')
plotTickLatex2D

subplot(2,1,2)
hold on
plot(t_total,x_total(:,22),'c--')
h1=plot(ts,m_gp2,'c');
plot(t_total,x_total(:,23),'b--')
h2=plot(ts,m_op2,'b');
plot(t_total,x_total(:,24),'r--')
h3=plot(ts,m_wp2,'r');
plot(t_total,x_total(:,25),'g--')
h4=plot(ts,m_gr2,'g');
plot(t_total,x_total(:,26),'m--')
h5=plot(ts,m_or2,'m');
plot(t_total,x_total(:,27),'k--')
h6=plot(ts,m_wr2,'k');


xlabel('t $[h]$')
ylabel('Flowline 2')
plotTickLatex2D

set(gcf, 'units','centimeters');
set(gcf, 'position', [1, 2, 17.6, 11]) % [0 0 W H];

%legend([h1 h2 h3 h4 h5 h6],'$m_{gp}$','$m_{op}$','$m_{wp}$','$m_{gr}$','$m_{or}$','$m_{wr}$')
legend( '$m_{gp}$ Matlab','$m_{gp}$ CVODE',...
        '$m_{op}$ Matlab','$m_{op}$ CVODE',...
        '$m_{wp}$ Matlab','$m_{wp}$ CVODE',...
        '$m_{gr}$ Matlab','$m_{gr}$ CVODE',...
        '$m_{or}$ Matlab','$m_{or}$ CVODE',...
        '$m_{wr}$ Matlab','$m_{wr}$ CVODE')

set(findall(gcf,'-property','interpreter'),'interpreter','latex') 
%% 
figure(3)
clf

subplot(2,1,1)
hold on
plot(t_total,y(7,:),'g--')
plot(ts,w_gout1,'g')
plot(t_total,y(8,:),'k--')
plot(ts,w_oout1,'k')
plot(t_total,y(9,:),'b--')
plot(ts,w_wout1,'b')

ylabel('Flowline 1')
title('Mass flow $[kg/s]$')
plotTickLatex2D
subplot(2,1,2)
hold on
plot(t_total,y(10,:),'g--')
h1=plot(ts,w_gout2,'g');
plot(t_total,y(11,:),'k--')
h2=plot(ts,w_oout2,'k');
plot(t_total,y(12,:),'b--')
h3=plot(ts,w_wout2,'b');

xlabel('t $[h]$')
ylabel('Flowline 2')
plotTickLatex2D

set(gcf, 'units','centimeters');
set(gcf, 'position', [1, 2, 17.6, 11]) % [0 0 W H];

%legend([h1 h2 h3],'$w_{gp}$','$w_{op}$','$w_{wp}$')

legend( '$w_{gp}$ Matlab','$w_{gp}$ CVODE',...
        '$w_{op}$ Matlab','$w_{op}$ CVODE',...
        '$w_{wp}$ Matlab','$w_{wp}$ CVODE')

set(findall(gcf,'-property','interpreter'),'interpreter','latex') 

%%

figure(4)
clf

hold on
stairs(t_total,u_y(:,2),'r')
stairs(t_total,u_y(:,4),'g')
stairs(t_total,u_y(:,6),'b')
stairs(t_total,u_y(:,8),'m')
stairs(t_total,u_y(:,10),'k')

xlabel('t $[h]$')
title('Mass flow $[kg/s]$')
ylabel('Control inputs')
axis([0 5 0.8 2])
plotTickLatex2D

set(gcf, 'units','centimeters');
set(gcf, 'position', [1, 2, 17.6, 8]) % [0 0 W H];

legend('$u_{gi,1}$','$u_{gi,2}$','$u_{gi,3}$','$u_{gi,4}$','$u_{gi,5}$')

set(findall(gcf,'-property','interpreter'),'interpreter','latex') 
